#ifndef __ALGORITHMAN__ODS_INTERFACE_H
    #define __ALGORITHMAN__ODS_INTERFACE_H

    // TODO:
    //       enable formulas
    //       adding rows and columns -> fix broken references!
    //       enable borders fonts, colors
    //       read title, foot etc. (styles.xml)

    #include "simple_xml.h"
    #ifdef __linux__
        #include <sys/stat.h>
    #else
        #error Sorry, but the open document spreadsheet interface only works on linux Systems.
    #endif
    #include <vector>
    #include <list>
    #include <fstream>
    #include <stdlib.h> // for getenv and system
    #include <unistd.h> // for getcwd
    #include <time.h> // for some meta.xml entries

    namespace AlgorithMan
    {    
    
        class Open_Document_Spreadsheet
        {
            public:
                Open_Document_Spreadsheet();
                Open_Document_Spreadsheet(std::string FileName);
            
                std::vector<std::vector<std::vector<std::string> > > Content;
                std::vector<std::string> SheetNames;
                std::string DocumentTitle;
                std::string DocumentFoot;
                bool Border;
            
                void LoadFromFile(std::string FileName);
                void SaveToFile(std::string FileName) const;
                void ExportToHTML(std::string FileName) const;
        
                int Sheets() const;
                int Rows(int Sheet=0) const;
                int Columns(int Sheet=0) const;
            
                void AddSheet(int rows=0, int columns=0, std::string name="");
                void AddRow(int Sheet=0);
                void AddColumn(int Sheet=0);
        };
        
    }

#endif
